# NOTE: Derived from blib/lib/CfgTie/Cfgfile.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::Cfgfile;

#line 211 "blib/lib/CfgTie/Cfgfile.pm (autosplit into blib/lib/auto/CfgTie/Cfgfile/END.al)"
sub END
{
   #This takes the current set of outstanding ties and rewrites the files
   foreach my $I (@Thingies)
    {
       #Skip it if there is nothing to do.
       if (!exists $I->{Queue} ||
           !scalar keys %{$I->{Queue}}) {next;}

       my $rewrite;
       #Build up rewrite rules:
       eval '$rewrite = $I->makerewrites();';
       if ($@)
         {
            #There was an error with the rewrite thing, skip this
            warn $@;
            next;
         }

       if (!defined $I->{Path}) {next;}
       if (!scalar keys %{$I->{Contents}}) {next;}
       if (-e $I->{Path} && !defined $I->{Queue}) {next;}

       #Announce that we will begin making changes
       eval '$I->cfg_begin();';

       #Check with the revision control system
       &RCS_Handshake($I);

       my($Base,$NewFileName);
       if ($I->{Path}=~/^([^\s]+)/ && $1 && length $1)
         {$Base=$1; $NewFileName = "$1,new";}
	else
	 {next;}

       if (-e $I->{Path})
         {
            #Next rewrite file...
            # Do the file rewrite
            my $FIn = new Secure::File "<$Base" or die "Could not open file ($Base) for reading: $!\n";
            my $FOut = new Secure::File ">$NewFileName" or die "Could not open the temporary output file ($NewFileName): $!\n";
            my $S=[];
            while (<$FIn>)
             {
                 my $L = &$rewrite($_,$S);
                if (defined $L) {print $FOut $L;}
             }
            $FIn->close();
	    $FOut->close();
         }
        else
         {
            if (defined $I->{RCS})
              {$Files2CheckIn{$Base} = $I->{RCS};}
            my $FOut = new Secure::File ">$NewFileName" or die "Could not open the output file ($Base): $!\n";
            foreach my $k (keys %{$I->{Contents}})
             {
                my $x=$I->{Contents}->{$k};
                print $FOut eval '$J->format($k,$x)';
                print $FOut "\n";
             }
	    $FOut->close;
         }
       #Swap the file
       if (-e $NewFileName)
         {
            #Rotate the file in
            &CfgTie::filever'Rotate($Base,$NewFileName);
         }

       #Announce that we are done making changes
       eval '$I->cfg_end();';
    }

   #Check in each of the files that need to be
   foreach my $I (keys %Files2CheckIn)
    {
       my $Obj =$Files2CheckIn{$I};
       my $Cmt;
       if (exists $Obj->{Comments})
         {
            $Cmt = $Obj->{Comments};
            $Cmt =~ s/\n/ /g;
         }
        else
         {$Cmt="Settings changed through the PERL-based envmgr";}
       my @Args = ('-u',"-m$Cmt");
       #Check to see if we need an initial description.
       if (!defined $Obj->comments) {@Args=(@Args, '-t-');}
#       print "Checkin' in\n";
       $Obj->ci(@Args);
    }
   %Files2CheckIn=();
}

# end of CfgTie::Cfgfile::END
1;
