# NOTE: Derived from blib/lib/CfgTie/TieAliases.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::TieAliases;

#line 130 "blib/lib/CfgTie/TieAliases.pm (autosplit into blib/lib/auto/CfgTie/TieAliases/scan.al)"
sub scan
{
   # Read the aliases file
   my $self= shift;

   #A structure to help keep track of the files we employ
   my %files;
   if (!exists $self->{'Path'})
     {
        #Path has not been defined... define it to the default.
        $self->{'Path'} = '/etc/aliases';
     }

   my $F=new Secure::File "<".$self->{'Path'};
   if (!defined $F) {return;}

   $files{$self->{'Path'}}++;

   while (my $L=<$F>)
    {
       chomp $L;
       $L=~ s/\s*#.*$//;  #Remove the comments

       my $currpos=$F->tell;

       #Handle continuation lines
     LINE:
       while (<$F>)
       {
          if (!/^\s/)
            {
               #Done with the continuation lines... clean up and parse it.
               $F->seek($currpos, 0);
               last LINE;
            }

          #Only keep the stuff before the comment
          chomp;
          s/\s*#.*$//;

          #Glue this line onto the big *whole* line
          $L .= $_;

          #Save our place so we can get back to it later
          $currpos = $F->tell;
       }

       if ($L =~ /([^:]+):\s*([^\n]*)/i)
         {
           #Right here is where it gets special
           #Would need to carefully handle includes...
           foreach my $I (split(/[,\s]+/, $2))
            {
               if ($I =~ /:include:([^\s]*)/)
                 {
                    #Read in an include file
                    push @{$self->{Files}}, $1;
                    my $G = new Secure::File "<$1";
                    if (defined $G)
                      {
                         while(<$G>)
                          {
                             chomp;
                             s/\s*#.*$//;
                             push @{$self->{Contents}->{$1}}, split /[,\s]+/;
                          }
                         $G->close;
                      }
                 }
                else
                 {
                    push @{$self->{Contents}->{$1}},$I;
                 }
            }
         }
     }
   $F->close;
}

# end of CfgTie::TieAliases::scan
1;
