# NOTE: Derived from blib/lib/CfgTie/TieNamed.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::TieNamed;

#line 443 "blib/lib/CfgTie/TieNamed.pm (autosplit into blib/lib/auto/CfgTie/TieNamed/Check_Bidir.al)"
#Parameter one is to strip off the base name portion of the address
#Parameter two is the reverse look up hash
#The rest is the list
#Description
# This goes thru the list of entries and tries to dosome very flexible
# pattern matching to be sure that the reverse names match...  It will avoid
# any addresses that have multiple names, since there is no clear rule set on
# how this should be handled
#Return Value
# The number of entries modified.
sub Check_Bidir 
{
   my $self = shift; my $fwd = shift; my $RevN = shift;

   # Get the goodies of the real deal
#   if (exists $self->{delegate}) {$self = $self->{delegate};}

   my $Rev = $self->{Contents}->{primary}->{$RevN};
   my %Count;
   my %ShouldBe;
   my $PatPRecs;
   eval "\$PatPRecs = sub {my \$A=shift; if (\$A=~s/\.$fwd\.\$//i) {\$A;}}";
   die $@ if $@;

   while (scalar @_)
    {
       my $Addr = pop @_;
       my $I = pop @_;

       my ($N) = @{$Rev->{$Addr}->{PTR}};
       $_=lc($N);

       #Strip off the base
       #Skip it if it is talking about some other addresss range
       $_=&$PatPRecs($_);
       if (!$_) {next;}

       my $P = $_;
       #Strip off on the other side too
       $_ = &$PatPRecs(lc($I));
       if (!$_) {$_=lc($I);}
       if ($_ eq $P) {next;} #They match

       if (!exists $Count{$Addr}) {$Count{$Addr}=0;} else {$Count{$Addr}++;}
       $ShouldBe{$Addr}=$_.".$fwd.";
    }

   my $Cnt=0;
   foreach my $Addr (keys %Count)
    {
       if ($Count{$Addr}) {next;} #Skip those with lots and lots of xreferences
       #print "$Addr:Reverse name mismatch. Should be:", $ShouldBe{$Addr},"\n";
       $Rev->{$Addr}->{PTR} = $ShouldBe{$Addr};
       $Cnt++;
    }
   if ($Cnt)
     {(tied %{$Rev})->Comment_Add("Corrected several reverse lookup entries");}
   $Cnt;
}

# end of CfgTie::TieNamed::Check_Bidir
1;
