# NOTE: Derived from blib/lib/CfgTie/TieNamed.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::TieNamed;

#line 257 "blib/lib/CfgTie/TieNamed.pm (autosplit into blib/lib/auto/CfgTie/TieNamed/scan.al)"
# This reads in a named boot file.

# Key is the domain, value is a hash reference to settings for that domain.

sub scan
{
   #This scans the named.boot file
   my $self = shift;

   if (!exists $self->{Path})
     {
        # Hunt it down in the default place
           if (-e '/etc/named.boot') {$self->{Path}='/etc/named.boot';}
        else {die "can't find the path to the named boot file!\n";}
        #Should look elsewhere, like the start up files
     }

   my $dir='./';
   my $F = new Secure::File '<'.$self->{Path};
   return unless defined $F;

   while (<$F>)
    {
       if (/^\s*directory\s+([^\s\n;]+)\/?\s*/i)
         {
            #This sets the working directory for all of the following files.
            $dir = $1;
            $self->{Contents}->{directory}=[$1];
         }
       elsif (/^\s*primary\s+([^;]+)\s+([^;\n\s]+)/i)
         {
            #We have a set of primary domains that map to a particular file
            foreach my $I (split(/\s+/,$1))
             {
                my %newtie;
                my $x = $dir.'/'.$2;
                if (exists $self->{RCS})
                  {
                     my $xobj = Rcs->new();
                     &CfgTie::filever'RCS_path($xobj, $x);

                     $x = $xobj;
                  }
                tie %newtie,'CfgTie::TieNamed_primary', $x, $I;
                $self->{Contents}->{primary}->{$I} = \%newtie;
             }
         }
       elsif (/^\s*limit\s+([^\s\n;]+)\s+([^;\n]*)/i)
         {
            $self->{Contents}->{limit}->{$1} = [split /\s+/, $2];
         }
       elsif (/^\s*([^;\n\s]+)\s+([^;\n]*)/i && $1 && $2)
         {
            #Miscellaneous additional options
            my $l1 = lc($1);
            my $a;
            if (exists $self->{Contents}->{$l1})
              {$a =$self->{Contents}->{$l1};}
             else
              {$a = [];}


            $self->{Contents}->{$l1} = [@{$a}, split(/\s+/, $2)];
         }
    }
   $F->close;
}

# end of CfgTie::TieNamed::scan
1;
