# NOTE: Derived from blib/lib/CfgTie/TieNamed.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::TieNamed_primary;

#line 620 "blib/lib/CfgTie/TieNamed.pm (autosplit into blib/lib/auto/CfgTie/TieNamed_primary/SerialNum_next.al)"
package CfgTie::TieNamed_primary;
@ISA=qw(CfgTie::Cfgfile);
#A tie hash for a single primary file...

my @days_per_month=(31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

sub SerialNum_next($)
{
   # A routine to guess the human format of the serial number and come up with
   # the next one.  The minimal rule here is that the returned value will be
   # no matter what, greater than the previous one.
   # We are allowed 9 digits in base 10.
   my $SN = shift;

   my ($sec,$min,$hour,$MDay,$Month,$Year,$WDay,$YDay,$isDST)=localtime;

   #Try YEAR-MONTH-DayOfMonth-Rev
   #  We have to make general calendar boundary conditions, plus be at an
   #  earlier date than now.
   if ($SN =~ /^(\d\d\d\d)(\d\d)(\d\d)(\d)$/ &&
       $2 <= 12 && $3 <= $days_per_month[$2-1] &&
       ($1 < $Year ||
         ($1 == $Year && ($2 < $Month+1||($2==$Month+1&&$3<=$MDay+1)))))
     {
        # We passed the first part of the boundary conditions...
        my $NewSn = $Year.($Month+1).($MDay+1)."0";
        while ($NewSN <= $SN) {$NewSN++;}
        return $NewSN;
     }

   #Okay, try YEAR-WEEK-DayOfWeek-Rev
   my $Week;
   if ($YDay < $WDay) {$Week = 0;}
    else {$Week  = ($YDay-$WDay)/7;}

   if ($SN =~ /^(\d\d\d\d)(\d\d)(\d)(\d\d)$/ &&
       $2 <= 52 && $3 <= 7 &&
       ($1 < $Year ||
         ($1 == $Year && ($2 < $Week+1||($2==$Week+1&&$3<=$WDay+1)))
       ))
     {
        # We passed the first part of the boundary conditions...
        my $NewSn = $Year.($Week+1).($WDay+1)."00";
        while ($NewSN <= $SN) {$NewSN++;}
        return $NewSN;
     }

   #Okay try YEAR-DayOfYear-Rev
   if ($SN =~ /^(\d\d\d\d)(\d\d\d)(\d\d)$/ &&
       $2 <= 366  &&
       ($1 < $Year || ($1 == $Year && $2 <= $YDay+1)))
     {
        # We passed the first part of the boundary conditions...
        my $NewSn = $Year.($YDay+1)."000";
        while ($NewSN <= $SN) {$NewSN++;}
        return $NewSN;
     }

   #Didn't match anything... write a new one out.
   return $SN+1;
}

# end of CfgTie::TieNamed_primary::SerialNum_next
1;
