# NOTE: Derived from blib/lib/CfgTie/TieNamed.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package CfgTie::TieNamed_primary;

#line 768 "blib/lib/CfgTie/TieNamed.pm (autosplit into blib/lib/auto/CfgTie/TieNamed_primary/makerewrites.al)"
sub makerewrites
{
   my $self = shift;
   local $Sub;
   my $Rules = "\$Sub= sub {\n   \$_=shift; my \$S=shift;\n";
   my $Q = $self->{Queue};
   my $SOA;
   #Hunt down any changes to the SOA records...
   my @SKeys = grep /\\s\+SOA/, (keys %{$Q});

   if (!scalar @SKeys)
     {
        #No SOA records of note.. lets make our own.
        if (exists $self->{Domain})
          {
             my @A = @{$self->{Contents}->{$self->{Domain}}->{SOA}};
             my $D = $self->{Domain};
             $D =~ s/\./\\\./g; #Make sure the periods are literals
             #Bump the SOA serial number to indicate changes
             my $NSN =  SerialNum_next $A[2];

             #It is right there...
             $Rules .= '   if (s/^\s*(@|'.$D.
                     ')(\s+IN\s+SOA\s+)[^\(\n\s;]+\s+[^\(\n\s;]+\s+'.
                     '[^\s\n\(;]+/do{$1.$2."'.$A[0].' '. $A[1].' '.$NSN.
                     '"}/iex) {return $_;}'."\n";

             # A parenthesis too soon
             $Rules .= '   if (s/^\s*(@|'.$D.
                     ')(\s+IN\s+SOA\s+)[^\(\n\s;]+\s+[^\(\n\s;]+\s+'.
                     '([\(;])/do{$1.$2."'.$A[0].' '. $A[1].' ".$3}/iex) '.
                     '{$S->[0]="SOA"; $S->[1]=2; return $_;}'."\n";

             $Rules .= '   if (s/^\s*(@|'.$D.
                     ')(\s+IN\s+SOA\s+)[^\(\n\s;]+\s+([\(;])/do{$1.$2."'.
                     $A[0].' ".$3}/iex) '.
                     '{$S->[0]="SOA"; $S->[1]=1; return $_;}'."\n";

             $Rules .= '   if (s/^\s*(@|'.$D.
                     ')(\s+IN\s+SOA\s+[\(;])/$1$2/i)'.
                     '{$S->[0]="SOA"; $S->[1]=0; return $_;}'."\n";

             #Now we are in the parenthesis and need to figure out what to do
             $Rules .=
             'if ($S->[0]eq"SOA") {'.
             '  if ($S->[1]==0){'.
             '    if (s/^(\s*)[^\)\s;]+\s+[^\s\);]+\s+[^\s\);]+/do{$1."'.
                     $A[0].' '.$A[1].' '.$NSN.'"}/ex) '.
             '    {$S->[0]=""; return $_;} '."\n".

             '    if (s/^(\s*)[^\)\s;]+\s+[^\s\);]+/do{$1."'.$A[0].' '.
                    ' '.$A[1].'"}/ex) '.
             '    {$S->[1]=2; return $_;} '."\n".

             '    if (s/^(\s*)[^\)\s;]+/do{$1."'.$A[0].'"}/ex) '.
             '    {$S->[1]=1;} return $_;}'."\n".
             ' elsif ($S->[1]==1){'.
             '    if (s/^(\s*)[^\)\s;]+\s+[^\s\);]+/do{$1."'.$A[1].' '.
                   $NSN.'"}/ex) '.
             '    {$S->[0]=""; return $_;} '."\n".

             '    if (s/^(\s*)[^\)\s;]+/do{$1."'.$A[1].'"}/ex) '.
             '    {$S->[1]=2;} return $_;}'."\n".
             ' elsif ($S->[1]== 2 && s/^(\s*)[^\(\s\n]+/do{$1."'.$NSN.
                '"}/ex)   {$S->[0]=""; return $_;}}'."\n";

           }
     }
    else
     {
        #For each of these that exists make the proper rules...
        foreach my $I (@SKeys)
         {
            my @A = @{$self->{Queue}->{$I}->{SOA}};
            #Bump the SOA serial number to indicate changes
            $A[2] =  SerialNum_next $A[2];
         }
     }

   foreach my $I (keys %{$Q})
    {
          if (!defined $Q->{$I} || !length $Q->{$I})
            #Build a deletion rule
            {$Rules.="   if(/^\\s*$I\\s+/i){return;}";}
       elsif (ref($Q->{$I}) eq 'HASH') {next;}
       else
         {
            #Build a change value rule
            $Rules.='   if (s/^(\s*'.$I.'\s+)[^;\n]+/$1'.
                    join(',',@{$self->{Queue}{$I}}).'/) {return $_;}'."\n";
         }
    }
   $Rules .="\n   \$_;\n};\n";
   $@='';
   eval $Rules;
   if (defined $@ && length $@) {die "rewrite rules compilation failed: $@";}
   return $Sub;
}

# end of CfgTie::TieNamed_primary::makerewrites
1;
